/**************************************************************************************
* AUTHOR : MinZhenfei
* DATE   : 2011-2-21
* MODULE : common.h
*
* Command: 
*	IOCTRL Common Header
*
* Description:
*	Common data for the IoCtrl driver and application
*
****************************************************************************************
* Copyright (C) 2011 MinZhenfei.
****************************************************************************************/

#pragma once 

//#######################################################################################
// D E F I N E S
//#######################################################################################

#if DBG
#define dprintf DbgPrint
#else
#define dprintf
#endif

//ַ֧û
#define DEVICE_NAME                  L"\\Device\\devSDKrn"             // Driver Name
#define SYMBOLIC_LINK_NAME           L"\\DosDevices\\SDKrn"            // Symbolic Link Name
#define WIN32_LINK_NAME              "\\\\.\\SDKrn"                    // Win32 Link Name

//ַ֧û
#define SYMBOLIC_LINK_GLOBAL_NAME    L"\\DosDevices\\Global\\SDKrn"    // Symbolic Link Name

#define DATA_TO_APP                  "Hello World from Driver"

//
// Device IO Control Codes
//
#define IOCTL_BASE          0x800
#define MY_CTL_CODE(i)        \
    CTL_CODE                  \
    (                         \
        FILE_DEVICE_UNKNOWN,  \
        IOCTL_BASE + i,       \
        METHOD_BUFFERED,      \
        FILE_ANY_ACCESS       \
    )

#define IOCTL_HOOK					 MY_CTL_CODE(0)
#define IOCTRL_UNHOOK				 MY_CTL_CODE(1)
#define IOCTRL_GET_PROCESS           MY_CTL_CODE(2)
#define IOCTRL_STUDY				 MY_CTL_CODE(3)
#define IOCTRL_UNSTUDY				 MY_CTL_CODE(4)
#define IOCTRL_INITEVENT			 MY_CTL_CODE(5)
#define IOCTRL_CANRUN			     MY_CTL_CODE(6)
//
// TODO: Add your IOCTL define here
//



//
// TODO: Add your struct,enum(public) define here
//



/* EOF */

