// Rules.cpp : implementation file
//

#include "stdafx.h"
#include "SDMain.h"
#include "Rules.h"

#pragma comment(lib, "version.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

_RecordsetPtr pRecordSet = NULL;
/////////////////////////////////////////////////////////////////////////////

UINT ListRules( LPVOID pParam )
{
	
	//AfxMessageBox("!");
	CListCtrl* list = (CListCtrl*)pParam;
	CString strSql = "Select * From ProcessInfo";

	if (!OpenRecordSet(strSql))
	{
		return -1;
	}

	if (!pRecordSet->BOF)
	{
		pRecordSet->MoveFirst();
	}

	_variant_t varValue;
	for (int i=0; !pRecordSet->adoEOF; i++)
	{
		CString str;
		varValue = pRecordSet->GetFields()->GetItem("ProcessName")->Value;
		str = (LPTSTR)(_bstr_t)varValue;

		int index = list->InsertItem(0, str);

	//	list->SetItemText(index, 0, str);

		varValue = pRecordSet->GetFields()->GetItem("ProcessPath")->Value;
		str = (LPTSTR)(_bstr_t)varValue;
		list->SetItemText(index, 1, str);

		//varValue = pRecordSet->GetFields()->GetItem("MD5")->Value;
		//str = (LPTSTR)(_bstr_t)varValue;
		//list->SetItemText(i, 2, str);

		varValue = pRecordSet->GetFields()->GetItem("IsValidate")->Value;
		str = (LPTSTR)(_bstr_t)varValue;
		if (str == "1")
		{
			list->SetItemText(index, 2, "");
		}
		else
		{
			list->SetItemText(index, 2, "");
		}

		pRecordSet->MoveNext();
	}
	list->Invalidate();
	pRecordSet->Close();
	pRecordSet = NULL;
	return 0;
}

BOOL OpenRecordSet(CString& strSql)
{
	CSDMainApp* pApp = (CSDMainApp*)AfxGetApp();
	
	pRecordSet.CreateInstance(__uuidof(Recordset));
	try
	{
		pRecordSet->Open(strSql.AllocSysString(), 
			pApp->m_connection.GetInterfacePtr(), 
			adOpenDynamic, adLockOptimistic, adCmdText);
	}
	catch (_com_error e)
	{
		CString strError;
		strError.Format("ִsqlʱ쳣!\tϢ:%s",e.ErrorMessage());
		AfxMessageBox(strError);
		return FALSE;
	}
	return TRUE;
}


// CRules dialog


CRules::CRules(CWnd* pParent /*=NULL*/)
	: CDialog(CRules::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRules)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CRules::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRules)
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRules, CDialog)
	//{{AFX_MSG_MAP(CRules)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST, OnCustomdrawMyList)
	//}}AFX_MSG_MAP	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRules message handlers

BOOL CRules::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_list.InsertColumn(0, "ӳ");
	m_list.InsertColumn(1, "ӳ·");
	m_list.InsertColumn(2, "֤HASHֵ");
	m_list.SetColumnWidth(0, 100);
	m_list.SetColumnWidth(1, 200);
	m_list.SetColumnWidth(2, 100);

	m_list.SetExtendedStyle(LVS_EX_GRIDLINES  | LVS_EX_FULLROWSELECT);

// 	if (!ConnectionDB())
// 	{
// 		return -1;
// 	}

	AfxBeginThread(ListRules, &m_list);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRules::OnCustomdrawMyList( NMHDR* pNMHDR, LRESULT* pResult )
{
	NMLVCUSTOMDRAW* pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>( pNMHDR );
	
    // Take the default processing unless we set this to something else below.
    *pResult = 0;
	
    // First thing - check the draw stage. If it's the control's prepaint
    // stage, then tell Windows we want messages for every item.
    if ( CDDS_PREPAINT == pLVCD->nmcd.dwDrawStage )
	{
        *pResult = CDRF_NOTIFYITEMDRAW;
	}
	
	// This is the notification message for an item. We'll request
	// notifications before each subitem's prepaint stage.
	else if ( pLVCD->nmcd.dwDrawStage==CDDS_ITEMPREPAINT )
	{
		COLORREF	m_clrText;
		int			nItem = static_cast<int> (pLVCD->nmcd.dwItemSpec);
		
		// ıжʹListCtrlͬɫʵ
		CString str = m_list.GetItemText(nItem ,2);
		if (str == "")
		{
			m_clrText = RGB(0, 0, 0);
		}
		else
		{
			m_clrText = RGB(255, 0, 0);
		}
		pLVCD->clrText = m_clrText;
		*pResult = CDRF_DODEFAULT;
	}
}

BOOL CRules::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	if (pRecordSet != NULL)
	{
		pRecordSet->Close();
		pRecordSet = NULL;
	}
	return CDialog::DestroyWindow();
}
