// SDTrayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SDTray.h"
#include "SDTrayDlg.h"
#include "IniReader.h"
#include "IniWriter.h"
#include "md5.h"
#include "../SDKrn/common.h"
#include <winioctl.h>
#include  <io.h>

#pragma comment(lib, "md5.lib")

int nStart = 1, nStudy = 0;
_ConnectionPtr pConnection = NULL;
_RecordsetPtr pRecordSet = NULL;

#define WM_MY_TRAY_NOTIFICATION WM_USER+0

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////

UINT MyCheckThread( LPVOID pParam )
{
	DWORD dwRet;
	int nCanRun = 0;
	AfxMessageBox("߳ѿ");

	//豸
	HANDLE hDevice = OPEN_DEVICE();
	if (hDevice == INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("ͨʧܣ");
		return -1;
	}

	//ͬ¼
	HANDLE hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (hEvent == NULL)
	{
		AfxMessageBox("ͬ¼ʧܣ");
		return -1;
	}
	DeviceIoControl(hDevice, IOCTRL_INITEVENT, &hEvent, sizeof(HANDLE), NULL, NULL, &dwRet, NULL);

	while (1)
	{
		_variant_t varValue;
		CString strProcPath, strSql, strProcName;
		CHAR buffer[MAX_PATH] = {'\0'};
		DWORD dwRet;
		//ȡصĽ
		DeviceIoControl(hDevice, IOCTRL_GET_PROCESS, NULL, 0, buffer, MAX_PATH, &dwRet, NULL);
		//жϼǷ
		if (!nStart)
		{
			continue;
		}
		//ȡ·ǷΪ
		if (!strlen(buffer))
		{
			continue;
		}

		strSql.Format("Select * From ProcessInfo Where ProcessPath = '%s'",buffer); 
		if (!OpenRecordSet(strSql))
		{
			continue;
		}
		//αָһ¼
		if (!pRecordSet->BOF)
		{
			pRecordSet->MoveFirst();
		}

		//Ϊѧϰģʽ
		if (nStudy)
		{
			//жݿǷд¼
			if (pRecordSet->adoEOF)
			{
				//ȡļ
				strProcPath = buffer;	
				strProcName=strProcPath.Right(strProcPath.GetLength()-strProcPath.ReverseFind('\\')-1); 
				InsertData(strProcName.GetBuffer(strProcName.GetLength()), buffer, MD5File(buffer));		
			}
		}
		else //Ϊȫģʽ
		{		
			//MessageBox("wee");
			_variant_t varValue;
			CString strTemp, strMD5;
			if(!pRecordSet->adoEOF)
			{
				//ȡIsValidateֵ
				varValue = pRecordSet->GetFields()->GetItem("IsValidate")->Value;
				strTemp = (LPCTSTR)(_bstr_t)varValue;

				//Ҫ֤MD5
				if (strTemp == "1")
				{
					varValue = pRecordSet->GetFields()->GetItem("MD5")->Value;
					strTemp = (LPCTSTR)(_bstr_t)varValue;
					strMD5 = MD5File(buffer);
					if (!strcmp(strTemp, strMD5))
					{
						//ִ
						nCanRun = 1;
						DeviceIoControl(hDevice, IOCTRL_CANRUN, &nCanRun, sizeof(int), NULL, 0, &dwRet, NULL);
						SetEvent(hEvent);
					}
					else
					{
						//ֹ
						nCanRun = 0;
						DeviceIoControl(hDevice, IOCTRL_CANRUN, &nCanRun, sizeof(int), NULL, 0, &dwRet, NULL);
						SetEvent(hEvent);
						AfxMessageBox("ļHASHֵѾı䣬ܱȾ!");
					}
				}
				else //Ҫ֤MD5
				{
					//ֱ
					nCanRun = 1;
					DeviceIoControl(hDevice, IOCTRL_CANRUN, &nCanRun, sizeof(int), NULL, 0, &dwRet, NULL);
					SetEvent(hEvent);
				}
			}
			else //޴¼,ֱӽֹ
			{
				//ֹ
				nCanRun = 0;
				DeviceIoControl(hDevice, IOCTRL_CANRUN, &nCanRun, sizeof(int), NULL, 0, &dwRet, NULL);
				SetEvent(hEvent);
			}
		}

		pRecordSet->Close();
		pRecordSet = NULL;
	}
	CloseHandle(hDevice);
	CloseHandle(hEvent);
	return 0;
}

BOOL OpenRecordSet(CString& strSql)
{
	CSDTrayApp* pApp = (CSDTrayApp*)AfxGetApp();
	pRecordSet.CreateInstance(__uuidof(Recordset));
	try
	{
		pRecordSet->Open(strSql.AllocSysString(), pApp->m_connection.GetInterfacePtr(), adOpenDynamic, adLockOptimistic, adCmdText);
	}
	catch (_com_error e)
	{
		CString strError;
		strError.Format("ִsqlʱ쳣!\tϢ:%s",e.ErrorMessage());
		AfxMessageBox(strError);
		return FALSE;
	}
	return TRUE;
}

BOOL InsertData(CHAR* ProcessName, CHAR* ProcessPath, CHAR* MD5)
{
	CString strSql;
	strSql = "SELECT * FROM ProcessInfo";
	if (!OpenRecordSet(strSql))
	{
		return FALSE;
	}
	
	try
	{
		pRecordSet->AddNew();
		pRecordSet->PutCollect("ProcessName", _variant_t(ProcessName));
		pRecordSet->PutCollect("ProcessPath", _variant_t(ProcessPath));
		pRecordSet->PutCollect("MD5", _variant_t(MD5));
		pRecordSet->Update();
		AfxMessageBox("ݳɹ!");
	}
	catch (_com_error e)
	{
		CString strError;
		strError.Format("ʧ!  %s", e.ErrorMessage());
		AfxMessageBox(strError);
		return FALSE;
	}

	//pRecordSet->Close();
//	pRecordSet = NULL;

	return TRUE;
}

void SetStartAndStudy(int nStart, int nStudy)
{
	CIniWriter iniWriter(".\\SDConfig.ini");
	iniWriter.WriteInteger("Tray", "Start", nStart);
	iniWriter.WriteInteger("Tray", "Study", nStudy);
}

void GetStartAndStudy(int& nStart, int& nStudy)
{
	CIniReader iniReader(".\\SDConfig.ini");
	nStart = iniReader.ReadInteger("Tray", "Start", 1);
	nStudy = iniReader.ReadInteger("Tray", "Study", 0);
}

// CSDTrayDlg dialog
CSDTrayDlg::CSDTrayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDTrayDlg::IDD, pParent),m_trayIcon(IDM_TRAY)
{
	//{{AFX_DATA_INIT(CSDTrayDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDTrayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSDTrayDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSDTrayDlg, CDialog)
	//{{AFX_MSG_MAP(CSDTrayDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_NCPAINT()
	ON_MESSAGE(WM_MY_TRAY_NOTIFICATION, OnTrayNotification)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_COMMAND(IDM_MAIN, OnMain)
	ON_COMMAND(IDM_SAFEMODE, OnSafemode)
	ON_UPDATE_COMMAND_UI(IDM_SAFEMODE, OnUpdateSafemode)
	ON_COMMAND(IDM_STARTMON, OnStartmon)
	ON_UPDATE_COMMAND_UI(IDM_STARTMON, OnUpdateStartmon)
	ON_COMMAND(IDM_STOPMON, OnStopmon)
	ON_UPDATE_COMMAND_UI(IDM_STOPMON, OnUpdateStopmon)
	ON_COMMAND(IDM_STUDYMODE, OnStudymode)
	ON_UPDATE_COMMAND_UI(IDM_STUDYMODE, OnUpdateStudymode)
	ON_WM_INITMENUPOPUP()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDTrayDlg message handlers

BOOL CSDTrayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//̵ӦϢ
	m_trayIcon.SetNotificationWnd(this, WM_MY_TRAY_NOTIFICATION);
	//ͼ
	GetStartAndStudy(nStart, nStudy);
	SetIcons(nStart, nStudy);

	AfxBeginThread(MyCheckThread, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSDTrayDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSDTrayDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSDTrayDlg::OnNcPaint() 
{
	// TODO: Add your message handler code here
	// Do not call CDialog::OnNcPaint() for painting messages
	static int i = 2; 
	if(i > 0) 
	{ 
		i--; 
		ShowWindow(SW_HIDE); 
	} 
	else 
		CDialog::OnNcPaint(); 
}

LRESULT CSDTrayDlg::OnTrayNotification(WPARAM uID, LPARAM lEvent)
{
	return m_trayIcon.OnTrayNotification(uID, lEvent);
}

void CSDTrayDlg::OnExit() 
{
	// TODO: Add your command handler code here
	m_trayIcon.DelIcon();
	SendMessage(WM_CLOSE);

	if (pConnection)
	{
		pConnection->Close();
		pConnection = NULL;
	}
	if(pRecordSet)
	{
		pRecordSet->Close();
		pRecordSet = NULL;
	}
	SetStartAndStudy(nStart, nStudy);
}

void CSDTrayDlg::OnMain() 
{
	// TODO: Add your command handler code here
	WinExec("SDMain.exe", SW_SHOW);
}

void CSDTrayDlg::SetIcons(int iStart,int iStudy)
{
	if (iStart == 1 && iStudy == 1)
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_RED);
		m_trayIcon.SetIcon(hIcon,"fuck");
	}
	else if (iStart == 1 && iStudy == 0)
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_GREEN);
		m_trayIcon.SetIcon(hIcon,"fuck");
	}
	else
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_GRAY);
		m_trayIcon.SetIcon(hIcon,"fuck");
	}
}


void CSDTrayDlg::OnSafemode() 
{
	// TODO: Add your command handler code here
	DWORD dwRet;
	HANDLE hDevice = OPEN_DEVICE();
	if (hDevice == INVALID_HANDLE_VALUE)
	{
		MessageBox("ͨʧܣ");
		return;
	}
	DeviceIoControl(hDevice, IOCTRL_UNSTUDY, NULL, 0, NULL, 0, &dwRet, NULL);
	CloseHandle(hDevice);

	nStudy = 0;
	if (nStart == 0)
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_GRAY);
		m_trayIcon.SetIcon(hIcon, "FCUK");
	}
	else
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_GREEN);
		m_trayIcon.SetIcon(hIcon, "FCUK");
	}
}

void CSDTrayDlg::OnUpdateSafemode(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (!nStudy)
	{
		pCmdUI->SetCheck();
	}
}

void CSDTrayDlg::OnStartmon() 
{
	// TODO: Add your command handler code here
	DWORD dwRet;
	HANDLE hDevice = OPEN_DEVICE();
	if (hDevice == INVALID_HANDLE_VALUE)
	{
		MessageBox("ͨʧ!");
		return;
	}
	
	DeviceIoControl(hDevice, IOCTL_HOOK, NULL, 0, NULL, 0, &dwRet, NULL);
	CloseHandle(hDevice);


	nStart = 1;
	if (nStudy == 1)
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_RED);
		m_trayIcon.SetIcon(hIcon, "FCUK");
	}
	else
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_GREEN);
		m_trayIcon.SetIcon(hIcon, "FCUK");
	}
}

void CSDTrayDlg::OnUpdateStartmon(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (nStart)
	{
		pCmdUI->SetCheck();
	}	
}

void CSDTrayDlg::OnStopmon() 
{
	// TODO: Add your command handler code here
	DWORD dwRet;
	HANDLE hDevice = OPEN_DEVICE();
	if (hDevice == INVALID_HANDLE_VALUE)
	{
		MessageBox("ͨʧ!");
		return;
	}
	
	DeviceIoControl(hDevice, IOCTRL_UNHOOK, NULL, 0, NULL, 0, &dwRet, NULL);
	CloseHandle(hDevice);

	nStart = 0;
	HICON hIcon = AfxGetApp()->LoadIcon(IDI_GRAY);
	m_trayIcon.SetIcon(hIcon, "FCUK");
}

void CSDTrayDlg::OnUpdateStopmon(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (!nStart)
	{
		pCmdUI->SetCheck();
	}
}

void CSDTrayDlg::OnStudymode() 
{
	// TODO: Add your command handler code here
	DWORD dwRet;
	HANDLE hDevice = OPEN_DEVICE();
	if (hDevice == INVALID_HANDLE_VALUE)
	{
		MessageBox("ͨʧ!");
		return;
	}
	
	DeviceIoControl(hDevice, IOCTRL_STUDY, NULL, 0, NULL, 0, &dwRet, NULL);
	CloseHandle(hDevice);

	nStudy = 1;
	if (nStart == 0)
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_GRAY);
		m_trayIcon.SetIcon(hIcon, "FCUK");
	}
	else
	{
		HICON hIcon = AfxGetApp()->LoadIcon(IDI_RED);
		m_trayIcon.SetIcon(hIcon, "FCUK");
	}

}

void CSDTrayDlg::OnUpdateStudymode(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (nStudy)
	{
		pCmdUI->SetCheck();
	}
}

void CSDTrayDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	//CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	
	// TODO: Add your message handler code here
	ASSERT(pPopupMenu != NULL);
	// Check the enabled state of various menu items.
	
	CCmdUI state;
	state.m_pMenu = pPopupMenu;
	ASSERT(state.m_pOther == NULL);
	ASSERT(state.m_pParentMenu == NULL);
	
	// Determine if menu is popup in top-level menu and set m_pOther to
	// it if so (m_pParentMenu == NULL indicates that it is secondary popup).
	HMENU hParentMenu;
	if (AfxGetThreadState()->m_hTrackingMenu == pPopupMenu->m_hMenu)
		state.m_pParentMenu = pPopupMenu;    // Parent == child for tracking popup.
	else if ((hParentMenu = ::GetMenu(m_hWnd)) != NULL)
	{
		CWnd* pParent = this;
		// Child Windows don't have menus--need to go to the top!
		if (pParent != NULL &&
			(hParentMenu = ::GetMenu(pParent->m_hWnd)) != NULL)
		{
			int nIndexMax = ::GetMenuItemCount(hParentMenu);
			for (int nIndex = 0; nIndex < nIndexMax; nIndex++)
			{
				if (::GetSubMenu(hParentMenu, nIndex) == pPopupMenu->m_hMenu)
				{
					// When popup is found, m_pParentMenu is containing menu.
					state.m_pParentMenu = CMenu::FromHandle(hParentMenu);
					break;
				}
			}
		}
	}
	
	state.m_nIndexMax = pPopupMenu->GetMenuItemCount();
	for (state.m_nIndex = 0; state.m_nIndex < state.m_nIndexMax;
	state.m_nIndex++)
	{
		state.m_nID = pPopupMenu->GetMenuItemID(state.m_nIndex);
		if (state.m_nID == 0)
			continue; // Menu separator or invalid cmd - ignore it.
		
		ASSERT(state.m_pOther == NULL);
		ASSERT(state.m_pMenu != NULL);
		if (state.m_nID == (UINT)-1)
		{
			// Possibly a popup menu, route to first item of that popup.
			state.m_pSubMenu = pPopupMenu->GetSubMenu(state.m_nIndex);
			if (state.m_pSubMenu == NULL ||
				(state.m_nID = state.m_pSubMenu->GetMenuItemID(0)) == 0 ||
				state.m_nID == (UINT)-1)
			{
				continue;       // First item of popup can't be routed to.
			}
			state.DoUpdate(this, TRUE);   // Popups are never auto disabled.
		}
		else
		{
			// Normal menu item.
			// Auto enable/disable if frame window has m_bAutoMenuEnable
			// set and command is _not_ a system command.
			state.m_pSubMenu = NULL;
			state.DoUpdate(this, FALSE);
		}
		
		// Adjust for menu deletions and additions.
		UINT nCount = pPopupMenu->GetMenuItemCount();
		if (nCount < state.m_nIndexMax)
		{
			state.m_nIndex -= (state.m_nIndexMax - nCount);
			while (state.m_nIndex < nCount &&
				pPopupMenu->GetMenuItemID(state.m_nIndex) == state.m_nID)
			{
				state.m_nIndex++;
			}
		}
		state.m_nIndexMax = nCount;
	}
}

void CSDTrayDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	AfxBeginThread(MyCheckThread, NULL);
}

void CSDTrayDlg::OnButton2() 
{
	if(_access("c:\\test.exe", 0))
	{
		MessageBox("ļ");
	}
}

BOOL CSDTrayDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	if (pRecordSet != NULL)
	{
		pRecordSet->Close();
		pRecordSet = NULL;
	}
	return CDialog::DestroyWindow();
}
