// SDTrayDlg.h : header file
//

#if !defined(AFX_SDTRAYDLG_H__F6269DA0_254A_4F72_BA54_8EAAC505A538__INCLUDED_)
#define AFX_SDTRAYDLG_H__F6269DA0_254A_4F72_BA54_8EAAC505A538__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TrayIcon.h"
/////////////////////////////////////////////////////////////////////////////
// CSDTrayDlg dialog
void SetStartAndStudy(int nStart, int nStudy);
void GetStartAndStudy(int& nStart, int& nStudy);
BOOL OpenRecordSet(CString& strSql);
BOOL InsertData(CHAR* ProcessName, CHAR* ProcessPath, CHAR* MD5);

#define		OPEN_DEVICE()			CreateFile( "\\\\.\\SDKrn", \
											GENERIC_ALL, \
											0, \
											NULL, \
											OPEN_EXISTING, \
											FILE_ATTRIBUTE_NORMAL, \
											NULL)


class CSDTrayDlg : public CDialog
{
// Construction
public:
	CSDTrayDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSDTrayDlg)
	enum { IDD = IDD_SDTRAY_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSDTrayDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
private:
	void SetIcons(int iStart,int iStudy);
	CTrayIcon m_trayIcon;
	// Generated message map functions
	//{{AFX_MSG(CSDTrayDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnNcPaint();
	afx_msg LRESULT OnTrayNotification(WPARAM wp, LPARAM lp);
	afx_msg void OnExit();
	afx_msg void OnMain();
	afx_msg void OnSafemode();
	afx_msg void OnUpdateSafemode(CCmdUI* pCmdUI);
	afx_msg void OnStartmon();
	afx_msg void OnUpdateStartmon(CCmdUI* pCmdUI);
	afx_msg void OnStopmon();
	afx_msg void OnUpdateStopmon(CCmdUI* pCmdUI);
	afx_msg void OnStudymode();
	afx_msg void OnUpdateStudymode(CCmdUI* pCmdUI);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SDTRAYDLG_H__F6269DA0_254A_4F72_BA54_8EAAC505A538__INCLUDED_)
